SystemOrganization addCategory: #ROSDDS!
SystemOrganization addCategory: 'ROSDDS-Commandline'!
SystemOrganization addCategory: 'ROSDDS-Protocolo'!
SystemOrganization addCategory: 'ROSDDS-Proxy'!
SystemOrganization addCategory: 'ROSDDS-Server-Domain'!
SystemOrganization addCategory: 'ROSDDS-Typeloader'!

!DDSExternallyDefinedDomain class methodsFor: '*ROSDDS' stamp: 'SantiagoBragagnolo 11/19/2014 18:41'!
onROS: anUrl
	^ self on: (DDSRemoteDomainMirror onROS: anUrl)! !

DDSDomainProxy subclass: #ROSDomainProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Proxy'!

!ROSDomainProxy commentStamp: 'SantiagoBragagnolo 11/13/2014 22:59' prior: 0!
Since the Simple DDS implementation is based on the ROS implementation, but without the structural installation, the type loader is completely different. And that is the main difference.!

!ROSDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 14:25'!
findParticipantByName: aName
| uri |
	uri := proxy lookupNode: aName with: '/NotAnActualID'.
	^ DDSParticipantDescriptor domain: nil name: aName uri: uri. ! !

!ROSDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 14:24'!
findServiceByName: aName
| uri |
	uri := proxy lookupService: aName with: '/NotAnActualID'.
	^ ROSServiceDescriptor domain: nil name: aName uri: uri. ! !

!ROSDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 23:00'!
registerTypeDefinition: aTypeDefinition
	^ self error: 'ROS bridge does not support type deploying'! !

!ROSDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 10:31'!
systemState
	^ proxy getSystemState: '/NotAnActualID'! !

!ROSDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 22:58'!
typeLoader
	^ typeLoader ifNil: [ typeLoader := ROSTypeLoder commandBased ]! !

!ROSDomainProxy methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 3/5/2015 15:33'!
url
	^ proxy url asString! !

DDSTCPProtocol subclass: #ROSTCPProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Protocolo'!

!ROSTCPProtocol commentStamp: 'SantiagoBragagnolo 11/13/2014 22:56' prior: 0!
Since the ROS protocol is the base of the simple DDS protocol, the implementation by default is the same, but it changes the name!

!ROSTCPProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 22:52'!
name 
	^ 'TCPROS'.! !

MDDSEntity subclass: #ROSServiceDescriptor
	instanceVariableNames: 'uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Proxy'!

!ROSServiceDescriptor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 13:56'!
domain: aDomain name: aParticipantName uri: anUri.
	^ (super  domain: aDomain name: aParticipantName ) uri: anUri; yourself
	! !

!ROSServiceDescriptor methodsFor: 'registration' stamp: 'SantiagoBragagnolo 2/11/2015 14:07'!
register: aRosaParticipant 
	aRosaParticipant registerService: self. ! !

!ROSServiceDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 13:57'!
uri: anUri
	uri := anUri ! !

DDSDomainDescriptorXMLRPCServer subclass: #ROSDomainDescriptorServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Server-Domain'!

!ROSDomainDescriptorServer commentStamp: 'SantiagoBragagnolo 11/17/2014 17:04' prior: 0!
By now is jus!

MDDSTypeLoader subclass: #ROSTypeLoder
	instanceVariableNames: 'builtinTypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Typeloader'!

!ROSTypeLoder commentStamp: 'SantiagoBragagnolo 9/19/2014 21:07' prior: 0!
The type loader is an abstract class that defines a basic cache and abstract methods.
It can be subclassed for usign command oriented loading (rosmsg) and  other kind of strategies it is not prepared to be mixed ( since there is una cahce per loader )!

ROSTypeLoder subclass: #ROSCommandTypeLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Typeloader'!

!ROSCommandTypeLoader commentStamp: 'SantiagoBragagnolo 9/19/2014 21:09' prior: 0!
This Loader parses the text file related with the definition the type obtained from the rosmsg command. To be useful it requires to be installed in a ros suited linux (platform dependant) and sourced in the environment used to load the image.
It has several restrictions, but is good enough for prototyping !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 11/23/2014 19:59'!
browseAll
	^ (Character lf split: (ROSSystemLauncher instance rosMsg: 'list'))
		inject: Dictionary new
		into: [ :acc :typeId | acc at: typeId put: (self typeDefinition: typeId). acc ].! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 11/13/2014 22:29'!
loadTypeDefinition: aTypeId ifAbsent: aBlock
	| firstLevel type val |
	[ val := ROSSystemLauncher instance rosMsgShow: aTypeId ]
		on: Error
		do: [ ^ aBlock value ].
	firstLevel := (Character lf split: val) select: [ :str | (str beginsWith: ' ') not & (str size > 3) ].
	type := self typeNamed: aTypeId for: firstLevel.
	type md5sum: (ROSSystemLauncher instance rosMsgMd5: aTypeId).
	^ type! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	| firstLevel type |
	firstLevel := (Character lf split: aStringDefinition) select: [ :str | (str beginsWith: ' ') not & (str size > 3) ].
	type := self typeNamed: aName for: firstLevel.
	^ type! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 10/20/2014 22:01'!
parseConstantRosLine: aLine
	| typeLine |
	typeLine := $= split: aLine.
	^ (self parseItemRosLine: (typeLine at: 1) into: MDDSConstantDefinition)
		value: (typeLine at: 2);
		yourself! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 10/20/2014 22:01'!
parseFieldRosLine: aLine
	^ self parseItemRosLine: aLine into: MDDSFieldDefinition! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 10/20/2014 22:01'!
parseItemRosLine: aLine into: aClass
	| fieldType fieldName |
	fieldType := self parseType: (($  split: aLine) at: 1).
	fieldName := ($  split: aLine) at: 2.
	^ aClass name: fieldName type: fieldType! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 10/20/2014 22:02'!
parseRosLine: aLine
	^ (aLine indexOf: $=) = 0
		ifTrue: [ self parseFieldRosLine: aLine ]
		ifFalse: [ self parseConstantRosLine: aLine ]! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 11/26/2014 12:13'!
parseType: aTypeToken
	| openBraket closeBraket innerType |
	"
		Possible types
		Type
		Type[]
		Type[N]
	"
	openBraket := aTypeToken indexOf: $[.
	openBraket = 0
		ifTrue: [ 
			" Is a common type "
			^ self typeDefinition: aTypeToken ].
	closeBraket := aTypeToken indexOf: $].
	innerType := self typeDefinition: (aTypeToken copyFrom: 1 to: openBraket - 1).
	^ MDDSCollectionTypeDefinition
		for:
			(openBraket + 1 = closeBraket
				ifTrue: [ 
					" Is a typed array  "
					MDDSArrayType new ]
				ifFalse: [ 
					" Is a typed array with fixed size "
					MDDSArrayFixedLenghtType sized: (aTypeToken copyFrom: openBraket + 1 to: closeBraket - 1) ])
		storing: innerType! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 11/18/2014 16:09'!
plainTypeDefinitionFor: aType
	^ ROSSystemLauncher instance rosMsgShow: aType name! !

!ROSCommandTypeLoader methodsFor: 'loading' stamp: 'SantiagoBragagnolo 10/20/2014 22:02'!
typeNamed: aTypeId for: firstLevel
	^ MDDSTypeDefinition message named: aTypeId defined: (firstLevel collect: [ :f | self parseRosLine: f ])! !

!ROSTypeLoder class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
commandBased
	^ ROSCommandTypeLoader new.! !

!ROSTypeLoder methodsFor: 'initialization' stamp: 'SantiagoBragagnolo 11/13/2014 22:25'!
initialize

	super initialize.
	builtinTypes := Dictionary new.
	
	builtinTypes at: 'byte' put: (MDDSBasicTypeDefinition for:  MDDSInt8Type new).
	builtinTypes at: 'char' put: (MDDSBasicTypeDefinition for:  MDDSInt8Type new).
	builtinTypes at: 'bool' put: (MDDSBasicTypeDefinition for:  MDDSBoolType new).
	builtinTypes at: 'float32' put: (MDDSBasicTypeDefinition for:  MDDSFloat32Type new).
	builtinTypes at: 'float64' put: (MDDSBasicTypeDefinition for:  MDDSFloat64Type new).
	
	builtinTypes at: 'int8' put: (MDDSBasicTypeDefinition for:  MDDSInt8Type new).
	builtinTypes at: 'int16' put: (MDDSBasicTypeDefinition for:  MDDSInt16Type new).
	builtinTypes at: 'int32' put: (MDDSBasicTypeDefinition for:  MDDSInt32Type new).
	builtinTypes at: 'int64' put: (MDDSBasicTypeDefinition for:  MDDSInt64Type new).
	
	builtinTypes at: 'uint8' put: (MDDSBasicTypeDefinition for:  MDDSUInt8Type new).
	builtinTypes at: 'uint16' put: (MDDSBasicTypeDefinition for:  MDDSUInt16Type new).
	builtinTypes at: 'uint32' put: (MDDSBasicTypeDefinition for:  MDDSUInt32Type new).
	builtinTypes at: 'uint64' put: (MDDSBasicTypeDefinition for:  MDDSUInt64Type new).
	
	builtinTypes at: 'time' put: (MDDSBasicTypeDefinition for:  MDDSTimeType new).
	builtinTypes at: 'duration' put: (MDDSBasicTypeDefinition for:  MDDSDurationType new).
	builtinTypes at: 'string' put: (MDDSBasicTypeDefinition for:  MDDSStringType new).! !

!ROSTypeLoder methodsFor: 'initialization' stamp: 'SantiagoBragagnolo 11/13/2014 22:27'!
loadTypeDefinition: aTypeId ifAbsent: aBlock
	self subclassResponsibility! !

!ROSTypeLoder methodsFor: 'initialization' stamp: 'SantiagoBragagnolo 2/13/2015 21:55'!
typeDefinition: aTypeId ifAbsent: aBlock
	^ builtinTypes
		at: aTypeId
		ifAbsent: [ 
			| type |
			type := super typeDefinition: aTypeId ifAbsent:[  #loading ].
			type == #loading
				ifTrue: [ registry at: aTypeId put: (self loadTypeDefinition: aTypeId ifAbsent: aBlock) ]
				ifFalse: [ type ] ]! !

Object subclass: #ROSPlatformDataExtractor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Commandline'!

!ROSPlatformDataExtractor commentStamp: 'SantiagoBragagnolo 2/26/2015 23:26' prior: 0!
Platform reification. Needed for grabbing some information from the operative system. The default implementation is for UBUNTU.!

!ROSPlatformDataExtractor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/27/2015 17:37'!
executableOf: aParticipantPID
	^ self executableOf: aParticipantPID tmpFile: aParticipantPID hash asString! !

!ROSPlatformDataExtractor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/26/2015 23:16'!
executableOf: aParticipantPID tmpFile: aTempFileName
	| rosmsg outstream errstream return |
	outstream := StandardFileStream forceNewFileNamed: '/tmp/' , aTempFileName , '.tmp'.
	errstream := StandardFileStream forceNewFileNamed: '/tmp/error_' , aTempFileName , '.tmp'.
	rosmsg := ExternalUnixOSProcess
		forkAndExec: '/bin/readlink'
		arguments: {('/proc/{1}/exe' format: {aParticipantPID})}
		environment: nil
		descriptors:
			{(FileStream stdin).
			outstream.
			errstream}.
	[ rosmsg isComplete not ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
	rosmsg succeeded
		ifTrue: [ 
			return := outstream
				reset;
				upToEnd.
			outstream close.
			errstream close ]
		ifFalse: [ 
			Error
				signal:
					'Error reading process information'
						,
							(errstream
								reset;
								upToEnd).
			outstream close.
			errstream close ].
	^ return! !

!ROSPlatformDataExtractor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/27/2015 17:38'!
kill: aPid
	^ OSProcess command: ' kill -9 ', aPid asString! !

!ROSPlatformDataExtractor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/26/2015 23:20'!
packageOf: aParticipantPID 
	^ (self executableOf: aParticipantPID) asFileReference parent basename ! !

Object subclass: #ROSSystemLauncher
	instanceVariableNames: 'masterProcess turtleProcess gmappingProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROSDDS-Commandline'!

ROSSystemLauncher class
	instanceVariableNames: 'instance distro'!

!ROSSystemLauncher commentStamp: '<historical>' prior: 0!
A PhaROSSystemLauncher is facade for executing ros commands in the host machine!

ROSSystemLauncher class
	instanceVariableNames: 'instance distro'!

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2013 14:56'!
distro: aDistroSymbol
	distro := aDistroSymbol! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 7/25/2013 13:11'!
fuerte
	^'/opt/ros/fuerte/bin/'! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 7/25/2013 13:11'!
groovy
	^'/opt/ros/groovy/bin/'! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'pharos 2/21/2014 10:39'!
hydro
	^ '/opt/ros/hydro/bin/'! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'janniklaval 5/20/2014 06:27'!
indigo
	^'/opt/ros/indigo/bin/'! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'janniklaval 5/20/2014 06:28'!
initialize
	super initialize.
	distro := #indigo.! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2012 10:30'!
instance
	^ instance ifNil: [
		instance := super new.	
	]! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2012 10:21'!
new
	self error: 'This is a singleton object, use instance instead of new'.! !

!ROSSystemLauncher class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2013 14:56'!
path: aCommand
	^ (distro value: self) , '/', aCommand ! !

!ROSSystemLauncher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/17/2015 15:21'!
catkinFind: anArray
	^ self catkinFind: anArray tmpFile: anArray hash asString.! !

!ROSSystemLauncher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/17/2015 15:20'!
catkinFind: anArrayOfArguments tmpFile: aTempFileName
	| rosmsg outstream errstream return |
	outstream := StandardFileStream forceNewFileNamed: '/tmp/' , aTempFileName , '.tmp'.
	errstream := StandardFileStream forceNewFileNamed: '/tmp/error_' , aTempFileName , '.tmp'.
	rosmsg := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'catkin_find')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			outstream.
			errstream}.
	[ rosmsg isComplete not ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
	rosmsg succeeded
		ifTrue: [ 
			return := outstream
				reset;
				upToEnd.
			outstream close.
			errstream close ]
		ifFalse: [ 
			Error
				signal:
					'Error discovering service type. Is this process running in a ROS environment?'
						,
							(errstream
								reset;
								upToEnd).
			outstream close.
			errstream close ].
	^ return! !

!ROSSystemLauncher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/17/2015 15:22'!
catkinfindNodeDirectories: aPackageName
	^ self
		catkinFind:
			{'--without-underlays'.
			'--libexec'.
			'--share'.
			aPackageName}! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosMsg: aCommand
	^ self rosMsg: {aCommand} tmpFile: aCommand! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
rosMsg: anArrayOfArguments tmpFile: aTempFileName
	| rosmsg outstream errstream return |
	outstream := StandardFileStream forceNewFileNamed: '/tmp/' , aTempFileName , '.tmp'.
	errstream := StandardFileStream forceNewFileNamed: '/tmp/error_' , aTempFileName , '.tmp'.
	rosmsg := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'rosmsg')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			outstream.
			errstream}.
	[ rosmsg isComplete not ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
	rosmsg succeeded
		ifTrue: [ 
			return := outstream
				reset;
				upToEnd.
			outstream close.
			errstream close ]
		ifFalse: [ 
			Error
				signal:
					'Error discovering type. Is this process running in a ROS environment?'
						,
							(errstream
								reset;
								upToEnd).
			outstream close.
			errstream close ].
	^ return! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosMsg: aCommand with: aTypeId
	^ self
		rosMsg:
			{aCommand.
			aTypeId}
		tmpFile: (aTypeId copyReplaceAll: '/' with: '_')! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosMsgMd5: aTypeId
	^ (self rosMsg: 'md5' with: aTypeId) copyReplaceAll: String lf with: ''! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosMsgShow: aTypeId
	^ self rosMsg: 'show' with: aTypeId! !

!ROSSystemLauncher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/17/2015 12:15'!
rosPackage: aCommand
	^ self rosPackage: {aCommand} tmpFile: aCommand! !

!ROSSystemLauncher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/17/2015 12:18'!
rosPackage: anArrayOfArguments tmpFile: aTempFileName
	| rosmsg outstream errstream return |
	outstream := StandardFileStream forceNewFileNamed: '/tmp/' , aTempFileName , '.tmp'.
	errstream := StandardFileStream forceNewFileNamed: '/tmp/error_' , aTempFileName , '.tmp'.
	rosmsg := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'rospack')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			outstream.
			errstream}.
	[ rosmsg isComplete not ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
	rosmsg succeeded
		ifTrue: [ 
			return := outstream
				reset;
				upToEnd.
			outstream close.
			errstream close ]
		ifFalse: [ 
			Error
				signal:
					'Error discovering service type. Is this process running in a ROS environment?'
						,
							(errstream
								reset;
								upToEnd).
			outstream close.
			errstream close ].
	^ return! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosSrv: aCommand
	^ self rosSrv: {aCommand} tmpFile: aCommand! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
rosSrv: anArrayOfArguments tmpFile: aTempFileName
	| rosmsg outstream errstream return |
	outstream := StandardFileStream forceNewFileNamed: '/tmp/' , aTempFileName , '.tmp'.
	errstream := StandardFileStream forceNewFileNamed: '/tmp/error_' , aTempFileName , '.tmp'.
	rosmsg := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'rossrv')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			outstream.
			errstream}.
	[ rosmsg isComplete not ] whileTrue: [ (Delay forMilliseconds: 100) wait ].
	rosmsg succeeded
		ifTrue: [ 
			return := outstream
				reset;
				upToEnd.
			outstream close.
			errstream close ]
		ifFalse: [ 
			Error
				signal:
					'Error discovering service type. Is this process running in a ROS environment?'
						,
							(errstream
								reset;
								upToEnd).
			outstream close.
			errstream close ].
	^ return! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosSrv: aCommand with: aTypeId
	^ self
		rosSrv:
			{aCommand.
			aTypeId}
		tmpFile: (aTypeId copyReplaceAll: '/' with: '_')! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosSrvMd5: aTypeId
	^ self rosSrv: 'md5' with: aTypeId! !

!ROSSystemLauncher methodsFor: 'types' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosSrvShow: aTypeId
	^ self rosSrv: 'show' with: aTypeId! !

!ROSSystemLauncher methodsFor: 'launching' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
roslaunch: aConfigurationFile
	| roslaunch |
	roslaunch := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'roslaunch')
		arguments: {aConfigurationFile}
		environment: nil
		descriptors:
			{(FileStream stdin).
			(FileStream stdout).
			(FileStream stderr)}.
	roslaunch spinForRos: 50.
	^ roslaunch! !

!ROSSystemLauncher methodsFor: 'launching' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
roslaunchForTests: aContent
	| file |
	file := StandardFileStream forceNewFileNamed: '/tmp/content-empty-test.launch'.
	file nextPutAll: aContent.
	file flush.
	file close.
	^ (self roslaunch: '/tmp/content-empty-test.launch') asStickyReference! !

!ROSSystemLauncher methodsFor: 'launching' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
rosrun: anArrayOfArguments
	| process |
	process := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'rosrun')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			(FileStream stdout).
			(FileStream stderr)}.
	process spinForRos: 20.
	^ process! !

!ROSSystemLauncher methodsFor: 'launching' stamp: 'SantiagoBragagnolo 11/12/2014 13:44'!
rosservice: anArrayOfArguments
	| process |
	process := ExternalUnixOSProcess
		forkAndExec: (ROSSystemLauncher path: 'rosservice')
		arguments: anArrayOfArguments
		environment: nil
		descriptors:
			{(FileStream stdin).
			(FileStream stdout).
			(FileStream stderr)}.
	process spinForRos: 20.
	^ process! !

!ROSSystemLauncher methodsFor: 'launching' stamp: 'SantiagoBragagnolo 10/20/2014 22:00'!
rosserviceCall: anArrayOfArguments
	^ self rosservice: {'call'} , anArrayOfArguments! !

!DDSRemoteDomainMirror class methodsFor: '*ROSDDS' stamp: 'SantiagoBragagnolo 11/19/2014 18:42'!
onROS: anURL
	^ self  on: (ROSDomainProxy on: anURL )! !

!DDSRemoteDomainMirror methodsFor: '*ROSDDS' stamp: 'SantiagoBragagnolo 2/11/2015 14:07'!
findServiceByName: aServiceName
	^ proxy findServiceByName: aServiceName! !
ROSSystemLauncher initialize!
